#!/usr/bin/perl
# Read original include file, and output functions prototypes

$file = @ARGV[0];

if ( ! defined(open(FILE, $file)) ) {
	warn "Couldn't open $file: $!\n";
	exit;
}

while ($ligne = <FILE>) {
	if ($ligne =~ /extern +\"C\"/ ) {
		next;
	}

	if ($ligne !~ /^GLAPI/ ) {
		next;
	}

	while (! ($ligne =~ /\);/)) {
		chomp($ligne);
		$ligne .= " " . <FILE>;
	}

	$ligne =~ s/\t/ /g ;
	$ligne =~ s/ +/ /g ;

	if ($ligne =~ /GLAPI *(.* *\**) *GLAPIENTRY *(.*) *\( *(.*) *\);/) {
		$return_type = $1 ;
		$function_name = $2 ;
		$params = $3;
	} elsif ($ligne =~ /GLAPI *(.* *\**) *APIENTRY *(.*) *\( *(.*) *\);/) {
		$return_type = $1 ;
		$function_name = $2 ;
		$params = $3;
	} else {
		next;
	}

	print $return_type." ".$function_name."(".$params.");\n";
}
close(FILE);
