#!/usr/bin/perl
# Read original include file, and output functions prototypes

$file = @ARGV[0];

if ( ! defined(open(FILE, $file)) ) {
	warn "Couldn't open $file: $!\n";
	exit;
}

@excludeFuncsGL = (
	"glBlendColor",
	"glBlendEquation",
	"glDrawRangeElements",
	"glColorTable",
	"glColorTableParameterfv",
	"glColorTableParameteriv",
	"glCopyColorTable",
	"glGetColorTable",
	"glGetColorTableParameterfv",
	"glGetColorTableParameteriv",
	"glColorSubTable",
	"glCopyColorSubTable",
	"glConvolutionFilter1D",
	"glConvolutionFilter2D",
	"glConvolutionParameterf",
	"glConvolutionParameterfv",
	"glConvolutionParameteri",
	"glConvolutionParameteriv",
	"glCopyConvolutionFilter1D",
	"glCopyConvolutionFilter2D",
	"glGetConvolutionFilter",
	"glGetConvolutionParameterfv",
	"glGetConvolutionParameteriv",
	"glGetSeparableFilter",
	"glSeparableFilter2D",
	"glGetHistogram",
	"glGetMinmax",
	"glGetMinmaxParameterfv",
	"glGetMinmaxParameteriv",
	"glHistogram",
	"glMinmax",
	"glResetHistogram",
	"glResetMinmax",
	"glTexImage3D",
	"glTexSubImage3D",
	"glCopyTexSubImage3D",
	"glActiveTexture",
	"glClientActiveTexture",
	"glMultiTexCoord1d",
	"glMultiTexCoord1dv",
	"glMultiTexCoord1f",
	"glMultiTexCoord1fv",
	"glMultiTexCoord1i",
	"glMultiTexCoord1iv",
	"glMultiTexCoord1s",
	"glMultiTexCoord1sv",
	"glMultiTexCoord2d",
	"glMultiTexCoord2dv",
	"glMultiTexCoord2f",
	"glMultiTexCoord2fv",
	"glMultiTexCoord2i",
	"glMultiTexCoord2iv",
	"glMultiTexCoord2s",
	"glMultiTexCoord2sv",
	"glMultiTexCoord1d",
	"glMultiTexCoord1dv",
	"glMultiTexCoord3d",
	"glMultiTexCoord3dv",
	"glMultiTexCoord3f",
	"glMultiTexCoord3fv",
	"glMultiTexCoord3i",
	"glMultiTexCoord3iv",
	"glMultiTexCoord3s",
	"glMultiTexCoord3sv",
	"glMultiTexCoord4d",
	"glMultiTexCoord4dv",
	"glMultiTexCoord4f",
	"glMultiTexCoord4fv",
	"glMultiTexCoord4i",
	"glMultiTexCoord4iv",
	"glMultiTexCoord4s",
	"glMultiTexCoord4sv",
	"glLoadTransposeMatrixf",
	"glLoadTransposeMatrixd",
	"glMultTransposeMatrixf",
	"glMultTransposeMatrixd",
	"glSampleCoverage",
	"glCompressedTexImage3D",
	"glCompressedTexImage2D",
	"glCompressedTexImage1D",
	"glCompressedTexSubImage3D",
	"glCompressedTexSubImage2D",
	"glCompressedTexSubImage1D",
	"glGetCompressedTexImage",
	"glActiveTextureARB",
	"glClientActiveTextureARB",
	"glMultiTexCoord1dARB",
	"glMultiTexCoord1dvARB",
	"glMultiTexCoord1fARB",
	"glMultiTexCoord1fvARB",
	"glMultiTexCoord1iARB",
	"glMultiTexCoord1ivARB",
	"glMultiTexCoord1sARB",
	"glMultiTexCoord1svARB",
	"glMultiTexCoord2dARB",
	"glMultiTexCoord2dvARB",
	"glMultiTexCoord2fARB",
	"glMultiTexCoord2fvARB",
	"glMultiTexCoord2iARB",
	"glMultiTexCoord2ivARB",
	"glMultiTexCoord2sARB",
	"glMultiTexCoord2svARB",
	"glMultiTexCoord3dARB",
	"glMultiTexCoord3dvARB",
	"glMultiTexCoord3fARB",
	"glMultiTexCoord3fvARB",
	"glMultiTexCoord3iARB",
	"glMultiTexCoord3ivARB",
	"glMultiTexCoord3sARB",
	"glMultiTexCoord3svARB",
	"glMultiTexCoord4dARB",
	"glMultiTexCoord4dvARB",
	"glMultiTexCoord4fARB",
	"glMultiTexCoord4fvARB",
	"glMultiTexCoord4iARB",
	"glMultiTexCoord4ivARB",
	"glMultiTexCoord4sARB",
	"glMultiTexCoord4svARB",
	"glEnableTraceMESA",
	"glDisableTraceMESA",
	"glNewTraceMESA",
	"glEndTraceMESA",
	"glTraceAssertAttribMESA",
	"glTraceCommentMESA",
	"glTraceTextureMESA",
	"glTraceListMESA",
	"glTracePointerMESA",
	"glTracePointerRangeMESA"
);

@excludeFuncsGLext = (
	"glWeightbvARB",
	"glWeightsvARB",
	"glWeightivARB",
	"glWeightfvARB",
	"glWeightdvARB",
	"glWeightubvARB",
	"glWeightusvARB",
	"glWeightuivARB",
	"glWeightPointerARB",
	"glVertexBlendARB",
	"glCurrentPaletteMatrixARB",
	"glMatrixIndexubvARB",
	"glMatrixIndexusvARB",
	"glMatrixIndexuivARB",
	"glMatrixIndexPointerARB",
	"glDeleteObjectARB",
	"glGetHandleARB",
	"glDetachObjectARB",
	"glCreateShaderObjectARB",
	"glShaderSourceARB",
	"glCompileShaderARB",
	"glCreateProgramObjectARB",
	"glAttachObjectARB",
	"glLinkProgramARB",
	"glUseProgramObjectARB",
	"glValidateProgramARB",
	"glUniform1fARB",
	"glUniform2fARB",
	"glUniform3fARB",
	"glUniform4fARB",
	"glUniform1iARB",
	"glUniform2iARB",
	"glUniform3iARB",
	"glUniform4iARB",
	"glUniform1fvARB",
	"glUniform2fvARB",
	"glUniform3fvARB",
	"glUniform4fvARB",
	"glUniform1ivARB",
	"glUniform2ivARB",
	"glUniform3ivARB",
	"glUniform4ivARB",
	"glUniformMatrix2fvARB",
	"glUniformMatrix3fvARB",
	"glUniformMatrix4fvARB",
	"glGetObjectParameterfvARB",
	"glGetObjectParameterivARB",
	"glGetInfoLogARB",
	"glGetAttachedObjectsARB",
	"glGetUniformLocationARB",
	"glGetActiveUniformARB",
	"glGetUniformfvARB",
	"glGetUniformivARB",
	"glGetShaderSourceARB",
	"glBindAttribLocationARB",
	"glGetActiveAttribARB",
	"glGetAttribLocationARB",
	"glDrawBuffersARB",
	"glDeformationMap3dSGIX",
	"glDeformationMap3fSGIX",
	"glDeformSGIX",
	"glLoadIdentityDeformationMapSGIX",
	"glFogFuncSGIS",
	"glGetFogFuncSGIS",
	"glImageTransformParameteriHP",
	"glImageTransformParameterfHP",
	"glImageTransformParameterivHP",
	"glImageTransformParameterfvHP",
	"glGetImageTransformParameterivHP",
	"glGetImageTransformParameterfvHP",
	"glApplyTextureEXT",
	"glTextureLightEXT",
	"glTextureMaterialEXT",
	"glAsyncMarkerSGIX",
	"glFinishAsyncSGIX",
	"glPollAsyncSGIX",
	"glGenAsyncMarkersSGIX",
	"glDeleteAsyncMarkersSGIX",
	"glIsAsyncMarkerSGIX",
	"glVertexPointervINTEL",
	"glNormalPointervINTEL",
	"glColorPointervINTEL",
	"glTexCoordPointervINTEL",
	"glPixelTransformParameteriEXT",
	"glPixelTransformParameterfEXT",
	"glPixelTransformParameterivEXT",
	"glPixelTransformParameterfvEXT",
	"glTextureNormalEXT",
	"glTangent3bEXT",
	"glTangent3bvEXT",
	"glTangent3dEXT",
	"glTangent3dvEXT",
	"glTangent3fEXT",
	"glTangent3fvEXT",
	"glTangent3iEXT",
	"glTangent3ivEXT",
	"glTangent3sEXT",
	"glTangent3svEXT",
	"glBinormal3bEXT",
	"glBinormal3bvEXT",
	"glBinormal3dEXT",
	"glBinormal3dvEXT",
	"glBinormal3fEXT",
	"glBinormal3fvEXT",
	"glBinormal3iEXT",
	"glBinormal3ivEXT",
	"glBinormal3sEXT",
	"glBinormal3svEXT",
	"glTangentPointerEXT",
	"glBinormalPointerEXT",
	"glFinishTextureSUNX",
	"glGlobalAlphaFactorbSUN",
	"glGlobalAlphaFactorsSUN",
	"glGlobalAlphaFactoriSUN",
	"glGlobalAlphaFactorfSUN",
	"glGlobalAlphaFactordSUN",
	"glGlobalAlphaFactorubSUN",
	"glGlobalAlphaFactorusSUN",
	"glGlobalAlphaFactoruiSUN",
	"glReplacementCodeuiSUN",
	"glReplacementCodeusSUN",
	"glReplacementCodeubSUN",
	"glReplacementCodeuivSUN",
	"glReplacementCodeusvSUN",
	"glReplacementCodeubvSUN",
	"glReplacementCodePointerSUN",
	"glColor4ubVertex2fSUN",
	"glColor4ubVertex2fvSUN",
	"glColor4ubVertex3fSUN",
	"glColor4ubVertex3fvSUN",
	"glColor3fVertex3fSUN",
	"glColor3fVertex3fvSUN",
	"glNormal3fVertex3fSUN",
	"glNormal3fVertex3fvSUN",
	"glColor4fNormal3fVertex3fSUN",
	"glColor4fNormal3fVertex3fvSUN",
	"glTexCoord2fVertex3fSUN",
	"glTexCoord2fVertex3fvSUN",
	"glTexCoord4fVertex4fSUN",
	"glTexCoord4fVertex4fvSUN",
	"glTexCoord2fColor4ubVertex3fSUN",
	"glTexCoord2fColor4ubVertex3fvSUN",
	"glTexCoord2fColor3fVertex3fSUN",
	"glTexCoord2fColor3fVertex3fvSUN",
	"glTexCoord2fNormal3fVertex3fSUN",
	"glTexCoord2fNormal3fVertex3fvSUN",
	"glTexCoord2fColor4fNormal3fVertex3fSUN",
	"glTexCoord2fColor4fNormal3fVertex3fvSUN",
	"glTexCoord4fColor4fNormal3fVertex4fSUN",
	"glTexCoord4fColor4fNormal3fVertex4fvSUN",
	"glReplacementCodeuiVertex3fSUN",
	"glReplacementCodeuiVertex3fvSUN",
	"glReplacementCodeuiColor4ubVertex3fSUN",
	"glReplacementCodeuiColor4ubVertex3fvSUN",
	"glReplacementCodeuiColor3fVertex3fSUN",
	"glReplacementCodeuiColor3fVertex3fvSUN",
	"glReplacementCodeuiNormal3fVertex3fSUN",
	"glReplacementCodeuiNormal3fVertex3fvSUN",
	"glReplacementCodeuiColor4fNormal3fVertex3fSUN",
	"glReplacementCodeuiColor4fNormal3fVertex3fvSUN",
	"glReplacementCodeuiTexCoord2fVertex3fSUN",
	"glReplacementCodeuiTexCoord2fVertex3fvSUN",
	"glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN",
	"glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN",
	"glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN",
	"glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN",
	"glColorPointerListIBM",
	"glSecondaryColorPointerListIBM",
	"glEdgeFlagPointerListIBM",
	"glIndexPointerListIBM",
	"glNormalPointerListIBM",
	"glTexCoordPointerListIBM",
	"glVertexPointerListIBM",
	"glFogCoordPointerListIBM",
	"glIglooInterfaceSGIX",
	"glGetMapControlPointsNV",
	"glGetMapParameterivNV",
	"glGetMapParameterfvNV",
	"glGetMapAttribParameterivNV",
	"glGetMapAttribParameterfvNV",
	"glEvalMapsNV",
	"glCombinerStageParameterfvNV",
	"glGetCombinerStageParameterfvNV",
	"glTextureColorMaskSGIS",
	"glMapControlPointsNV",
	"glMapParameterivNV",
	"glMapParameterfvNV",
	"glTexBumpParameterivATI",
	"glTexBumpParameterfvATI",
	"glGetTexBumpParameterivATI",
	"glGetTexBumpParameterfvATI",
	"glGenFragmentShadersATI",
	"glBindFragmentShaderATI",
	"glDeleteFragmentShaderATI",
	"glBeginFragmentShaderATI",
	"glEndFragmentShaderATI",
	"glPassTexCoordATI",
	"glSampleMapATI",
	"glColorFragmentOp1ATI",
	"glColorFragmentOp2ATI",
	"glColorFragmentOp3ATI",
	"glAlphaFragmentOp1ATI",
	"glAlphaFragmentOp2ATI",
	"glAlphaFragmentOp3ATI",
	"glSetFragmentShaderConstantATI",
	"glPNTrianglesiATI",
	"glPNTrianglesfATI",
	"glNewObjectBufferATI",
	"glIsObjectBufferATI",
	"glUpdateObjectBufferATI",
	"glGetObjectBufferfvATI",
	"glGetObjectBufferivATI",
	"glFreeObjectBufferATI",
	"glArrayObjectATI",
	"glGetArrayObjectfvATI",
	"glGetArrayObjectivATI",
	"glVariantArrayObjectATI",
	"glGetVariantArrayObjectfvATI",
	"glGetVariantArrayObjectivATI",
	"glBeginVertexShaderEXT",
	"glEndVertexShaderEXT",
	"glBindVertexShaderEXT",
	"glGenVertexShadersEXT",
	"glDeleteVertexShaderEXT",
	"glShaderOp1EXT",
	"glShaderOp2EXT",
	"glShaderOp3EXT",
	"glSwizzleEXT",
	"glWriteMaskEXT",
	"glInsertComponentEXT",
	"glExtractComponentEXT",
	"glGenSymbolsEXT",
	"glSetInvariantEXT",
	"glSetLocalConstantEXT",
	"glVariantbvEXT",
	"glVariantsvEXT",
	"glVariantivEXT",
	"glVariantfvEXT",
	"glVariantdvEXT",
	"glVariantubvEXT",
	"glVariantusvEXT",
	"glVariantuivEXT",
	"glVariantPointerEXT",
	"glEnableVariantClientStateEXT",
	"glDisableVariantClientStateEXT",
	"glBindLightParameterEXT",
	"glBindMaterialParameterEXT",
	"glBindTexGenParameterEXT",
	"glBindTextureUnitParameterEXT",
	"glBindParameterEXT",
	"glIsVariantEnabledEXT",
	"glGetVariantBooleanvEXT",
	"glGetVariantIntegervEXT",
	"glGetVariantFloatvEXT",
	"glGetVariantPointervEXT",
	"glGetInvariantBooleanvEXT",
	"glGetInvariantIntegervEXT",
	"glGetInvariantFloatvEXT",
	"glGetLocalConstantBooleanvEXT",
	"glGetLocalConstantIntegervEXT",
	"glGetLocalConstantFloatvEXT",
	"glVertexStream1sATI",
	"glVertexStream1svATI",
	"glVertexStream1iATI",
	"glVertexStream1ivATI",
	"glVertexStream1fATI",
	"glVertexStream1fvATI",
	"glVertexStream1dATI",
	"glVertexStream1dvATI",
	"glVertexStream2sATI",
	"glVertexStream2svATI",
	"glVertexStream2iATI",
	"glVertexStream2ivATI",
	"glVertexStream2fATI",
	"glVertexStream2fvATI",
	"glVertexStream2dATI",
	"glVertexStream2dvATI",
	"glVertexStream3sATI",
	"glVertexStream3svATI",
	"glVertexStream3iATI",
	"glVertexStream3ivATI",
	"glVertexStream3fATI",
	"glVertexStream3fvATI",
	"glVertexStream3dATI",
	"glVertexStream3dvATI",
	"glVertexStream4sATI",
	"glVertexStream4svATI",
	"glVertexStream4iATI",
	"glVertexStream4ivATI",
	"glVertexStream4fATI",
	"glVertexStream4fvATI",
	"glVertexStream4dATI",
	"glVertexStream4dvATI",
	"glNormalStream3bATI",
	"glNormalStream3bvATI",
	"glNormalStream3sATI",
	"glNormalStream3svATI",
	"glNormalStream3iATI",
	"glNormalStream3ivATI",
	"glNormalStream3fATI",
	"glNormalStream3fvATI",
	"glNormalStream3dATI",
	"glNormalStream3dvATI",
	"glClientActiveVertexStreamATI",
	"glVertexBlendEnviATI",
	"glVertexBlendEnvfATI",
	"glElementPointerATI",
	"glDrawElementArrayATI",
	"glDrawRangeElementArrayATI",
	"glDrawMeshArraysSUN",
	"glGenOcclusionQueriesNV",
	"glDeleteOcclusionQueriesNV",
	"glIsOcclusionQueryNV",
	"glBeginOcclusionQueryNV",
	"glEndOcclusionQueryNV",
	"glGetOcclusionQueryivNV",
	"glGetOcclusionQueryuivNV",
	"glElementPointerAPPLE",
	"glDrawElementArrayAPPLE",
	"glDrawRangeElementArrayAPPLE",
	"glMultiDrawElementArrayAPPLE",
	"glMultiDrawRangeElementArrayAPPLE",
	"glGenFencesAPPLE",
	"glDeleteFencesAPPLE",
	"glSetFenceAPPLE",
	"glIsFenceAPPLE",
	"glTestFenceAPPLE",
	"glFinishFenceAPPLE",
	"glTestObjectAPPLE",
	"glFinishObjectAPPLE",
	"glBindVertexArrayAPPLE",
	"glDeleteVertexArraysAPPLE",
	"glGenVertexArraysAPPLE",
	"glIsVertexArrayAPPLE",
	"glVertexArrayRangeAPPLE",
	"glFlushVertexArrayRangeAPPLE",
	"glVertexArrayParameteriAPPLE",
	"glDrawBuffersATI",
	"glVertex2hNV",
	"glVertex2hvNV",
	"glVertex3hNV",
	"glVertex3hvNV",
	"glVertex4hNV",
	"glVertex4hvNV",
	"glNormal3hNV",
	"glNormal3hvNV",
	"glColor3hNV",
	"glColor3hvNV",
	"glColor4hNV",
	"glColor4hvNV",
	"glTexCoord1hNV",
	"glTexCoord1hvNV",
	"glTexCoord2hNV",
	"glTexCoord2hvNV",
	"glTexCoord3hNV",
	"glTexCoord3hvNV",
	"glTexCoord4hNV",
	"glTexCoord4hvNV",
	"glMultiTexCoord1hNV",
	"glMultiTexCoord1hvNV",
	"glMultiTexCoord2hNV",
	"glMultiTexCoord2hvNV",
	"glMultiTexCoord3hNV",
	"glMultiTexCoord3hvNV",
	"glMultiTexCoord4hNV",
	"glMultiTexCoord4hvNV",
	"glFogCoordhNV",
	"glFogCoordhvNV",
	"glSecondaryColor3hNV",
	"glSecondaryColor3hvNV",
	"glVertexWeighthNV",
	"glVertexWeighthvNV",
	"glVertexAttrib1hNV",
	"glVertexAttrib1hvNV",
	"glVertexAttrib2hNV",
	"glVertexAttrib2hvNV",
	"glVertexAttrib3hNV",
	"glVertexAttrib3hvNV",
	"glVertexAttrib4hNV",
	"glVertexAttrib4hvNV",
	"glVertexAttribs1hvNV",
	"glVertexAttribs2hvNV",
	"glVertexAttribs3hvNV",
	"glVertexAttribs4hvNV",
	"glPixelDataRangeNV",
	"glFlushPixelDataRangeNV",
	"glPrimitiveRestartNV",
	"glPrimitiveRestartIndexNV",
	"glMapObjectBufferATI",
	"glUnmapObjectBufferATI",
	"glStencilOpSeparateATI",
	"glStencilFuncSeparateATI",
	"glVertexAttribArrayObjectATI",
	"glGetVertexAttribArrayObjectfvATI",
	"glGetVertexAttribArrayObjectivATI"
);

while ($ligne = <FILE>) {
	if ($ligne =~ /extern +\"C\"/ ) {
		next;
	}

	if ($ligne !~ /^GLAPI/ ) {
		next;
	}

	while (! ($ligne =~ /\);/)) {
		chomp($ligne);
		$ligne .= " " . <FILE>;
	}

	$ligne =~ s/\t/ /g ;
	$ligne =~ s/ +/ /g ;

	if ($ligne =~ /GLAPI *(.* *\**) *GLAPIENTRY *(.*) *\( *(.*) *\);/) {
		$return_type = $1 ;
		$function_name = $2 ;
		$params = $3;
	} elsif ($ligne =~ /GLAPI *(.* *\**) *APIENTRY *(.*) *\( *(.*) *\);/) {
		$return_type = $1 ;
		$function_name = $2 ;
		$params = $3;
	} else {
		next;
	}

	if ($file =~ /gl.h/) {
		$exclude = 0;
		foreach $funcToExclude (@excludeFuncsGL) {
			if ($function_name =~ /$funcToExclude/) {
				$exclude=1;
				last;
			}
		}
		if ($exclude == 1) {
			next;
		}
	}

	if ($file =~ /glext.h/) {
		$exclude = 0;
		foreach $funcToExclude (@excludeFuncsGLext) {
			if ($function_name =~ /$funcToExclude/) {
				$exclude=1;
				last;
			}
		}
		if ($exclude == 1) {
			next;
		}
	}

	print $return_type." ".$function_name."(".$params.");\n";
}
close(FILE);
