#!/usr/bin/perl
# Read original include file, and output functions prototypes

$file = @ARGV[0];

if ( ! defined(open(FILE, $file)) ) {
	warn "Couldn't open $file: $!\n";
	exit;
}

@excludeFuncs = (
	"SDL_malloc",
	"SDL_calloc",
	"SDL_realloc",
	"SDL_free",
	"SDL_getenv",
	"SDL_putenv",
	"SDL_memset",
	"SDL_memcpy",
	"SDL_strlen",
	"SDL_strdup",
	"SDL_strchr",
	"SDL_strrchr",
	"SDL_ltoa",
	"SDL_ultoa",
	"SDL_strtol",
	"SDL_strtoul",
	"SDL_strtoll",
	"SDL_strtoul",
	"SDL_strcmp",
	"SDL_strncmp",
	"SDL_strcasecmp",
	"SDL_strncasecmp",
	"SDL_sscanf",
	"SDL_snprintf",
	"SDL_vsnprintf",
	"SDL_strstr",
	"SDL_qsort"
);

while ($ligne = <FILE>) {
	if ($ligne !~ /DECLSPEC/ ) {
		next;
	}

	while (! ($ligne =~ /\);/)) {
		chomp($ligne);
		$ligne .= " " . <FILE>;
	}
	$ligne =~ s/\t//g;
	$ligne =~ s/ \(/\(/;

	if ($ligne =~ /pfnSDL_CurrentBeginThread/) {
		next;
	}

	if ($ligne =~ /DECLSPEC *(\w+).* SDLCALL *(\w+) *\(.*/) {
		$return_type = $1 ;
		$function_name = $2 ;
	} else {
		$return_type = "" ;
		$function_name = "" ;
	}

	$exclude = 0;
	foreach $funcToExclude (@excludeFuncs) {
		if ($function_name =~ /$funcToExclude/) {
			$exclude=1;
			last;
		}
	}
	if ($exclude == 1) {
		next;
	}

	$ligne =~ s/extern *// ;
	$ligne =~ s/DECLSPEC *// ;
	$ligne =~ s/ *SDLCALL// ;
	$ligne =~ s/\t/ /g ;
	$ligne =~ s/ +/ /g ;
	$ligne =~ s/;$// ;
	chomp($ligne);

	print $ligne.";\n";
}
close(FILE);
