#!/usr/bin/perl
# Read original include file, and output functions prototypes

$file = @ARGV[0];

if ( ! defined(open(FILE, $file)) ) {
	warn "Couldn't open $file: $!\n";
	exit;
}

@excludeFuncs = (
	"png_err",
	"png_get_sCAL_s",
	"png_set_sCAL_s"
);

while ($ligne = <FILE>) {
	if ($ligne =~ /extern +\"C\"/ ) {
		next;
	}

	if ($ligne !~ /extern/ ) {
		next;
	}

	while (! ($ligne =~ /\);/)) {
		chomp($ligne);
		$ligne .= " " . <FILE>;
	}

	$ligne =~ s/\t/ /g ;
	$ligne =~ s/ +/ /g ;

	if ($ligne =~ /extern +PNG_EXPORT *\( *(.*) *, *(.*) *\) *PNGARG *\((.*)\);/) {
		$return_type = $1 ;
		$function_name = $2 ;
		$params = $3;
	} else {
		next;
	}

	$exclude = 0;
	foreach $funcToExclude (@excludeFuncs) {
		if ($function_name =~ /$funcToExclude/) {
			$exclude=1;
			last;
		}
	}
	if ($exclude == 1) {
		next;
	}

	print $return_type." ".$function_name.$params.";\n";
}
close(FILE);
