#!/usr/bin/perl
# Read original include file, and output functions prototypes

$file = @ARGV[0];

if ( ! defined(open(FILE, $file)) ) {
	warn "Couldn't open $file: $!\n";
	exit;
}

#print "/* Generated by gen_func.pl from $file */\n\n";

$linecount=0;
while ($ligne = <FILE>) {
	if ($ligne =~ /extern +\"C\"/ ) {
		next;
	}

	if ($ligne !~ /extern/ ) {
		next;
	}

	while (! ($ligne =~ /\);/)) {
		chomp($ligne);
		$ligne .= " " . <FILE>;
	}
	$ligne =~ s/\t//g;
	$ligne =~ s/ \(/\(/;

	if ($ligne =~ /=/) {
		next;
	}

	if ($ligne =~ /extern +(.*) +(TIFF\w+) *\(.*/) {
		$return_type = $1 ;
		$function_name = $2 ;
	} else {
		$return_type = "" ;
		$function_name = "" ;
	}

	if ($ligne =~ /TIFFOpenW/ ) {
		next;
	}

	if ($ligne =~ /(.*) __attribute__/) {
		$ligne = $1;
	}

	$ligne =~ s/extern *// ;
	$ligne =~ s/\t/ /g ;
	$ligne =~ s/ +/ /g ;
	$ligne =~ s/;$// ;
	chomp($ligne);

	print $ligne.";\n";

	$linecount++;
}
close(FILE);

#print "/* Functions generated: $linecount */\n";
