#!/bin/sh
#
#	Read function list, generate linker file
#
# Usage:
#  step2-ldg.sh <profilename>

mkdir -p build/linker/$1
mkdir -p build/pointer/$1
mkdir -p build/caller/$1
mkdir -p build/loader/$1
mkdir -p build/names/$1

for i in `cat profiles/$1/headers.txt`;
do
	echo "Generating LDG linker from file $i"
	./gen_link.pl build/functions/$1/$i > build/linker/$1/$i

	echo "Generating LDG pointer from file $i"
	./gen_pointer_asm.pl build/functions/$1/$i > build/pointer/$1/$i.S
	echo "Generating LDG caller from file $i"
	./gen_caller_asm.pl build/functions/$1/$i > build/caller/$1/$i.S
	echo "Generating LDG names from file $i"
	./gen_name_asm.pl build/functions/$1/$i > build/names/$1/$i.S
	echo "Generating LDG loader from file $i"
	./gen_loader_asm.pl build/functions/$1/$i > build/loader/$1/$i.S
done
