#!/usr/bin/perl
#
#	Read function list, generate final linker
#
# Usage:
#  step6-ldg.pl <profilename>

$file = @ARGV[0];

# Count number of functions

$count_func = 0;
$func_str = "";
$func_list = "";
$num_func = 1;
open(FILE, "profiles/".$file."/headers.txt");
while ($filename = <FILE>) {
	open(FILEFUNC, "build/functions/".$file."/".$filename);
	while ($ligne = <FILEFUNC>) {
		if ($ligne =~ /(.* +\**)(\w+) *\((.*)\);/ ) {
			$count_func++;
			$func_str .=
				"LC".$num_func.":\n".
					"\t.ascii\t\"".$2."\\0\"\n";
			$func_list .=
				"\t.long\tLC".$num_func."\n".
				"\t.long\tLC0\n".
				"\t.long\t_".$2."\n";
			$num_func++;
		}
	}
	close(FILEFUNC);
	chomp($filename);
}
close(FILE);

# Read template

$template = "";
open(FILE, "profiles/linker-ldg.S");
while ($ligne = <FILE>) {
	$template .= $ligne;
}
close(FILE);

$template =~ s/%LIB_VERSION%/0x100/;
$template =~ s/%NUM_FUNCS%/$count_func/;
$template =~ s/%LIB_NAME%/"lib$file\\0"/;
$template =~ s/%FUNC_NAMES%/$func_str/;
$template =~ s/%FUNC_LIST%/$func_list/;

# Write linker

mkdir "src";
mkdir "src/".$file;

open(FILE, ">src/".$file."/linker-ldg.S");
print FILE $template;
close(FILE);
