#!/usr/bin/perl
#
#	Read function list, generate final loader
#
# Usage:
#  step7-ldg.pl <profilename>

$file = @ARGV[0];

# Count number of functions

$caller_includes = "";
$loader_includes = "";
$pointer_includes = "";
$names_includes = "";
open(FILE, "profiles/".$file."/headers.txt");
while ($filename = <FILE>) {
	open(FILEFUNC, "build/functions/".$file."/".$filename);
	while ($ligne = <FILEFUNC>) {
		if ($ligne =~ /(.* +\**)(\w+) *\((.*)\);/ ) {
			$num_func++;
		}
	}
	close(FILEFUNC);
	chomp($filename);
	$caller_includes .= "#include \"build/caller/".$file."/".$filename.".S\"\n";
	$loader_includes .= "#include \"build/loader/".$file."/".$filename.".S\"\n";
	$pointer_includes .= "#include \"build/pointer/".$file."/".$filename.".S\"\n";
	$names_includes .= "#include \"build/names/".$file."/".$filename.".S\"\n";
}
close(FILE);

# Read template

$template = "";
open(FILE, "profiles/loader-ldg.S");
while ($ligne = <FILE>) {
	$template .= $ligne;
}
close(FILE);

$template =~ s/%CALLER_ASM%/$caller_includes/;
$template =~ s/%LOADER_ASM%/$loader_includes/;
$template =~ s/%POINTER_ASM%/$pointer_includes/;
$template =~ s/%FUNCNAME_ASM%/$names_includes/;
$template =~ s/%LIBNAME_ASM%/$file/g;

# Write loader

mkdir "src";
mkdir "src/".$file;

open(FILE, ">src/".$file."/loader-ldg.S");
print FILE $template;
close(FILE);
