 #!/bin/sh
#
#	Final step, compile everything
#
# Usage:
#  step8-ldg.sh <profilename>

CROSSDIR_ROOT=/home/patrice/local

export PATH=$CROSSDIR_ROOT/bin:$CROSSDIR_ROOT/m68k-atari-mint/bin:$PATH
export LD_LIBRARY_PATH=$CROSSDIR_ROOT/lib:$LD_LIBRARY_PATH

CC=m68k-atari-mint-gcc
AR=m68k-atari-mint-ar
RANLIB=m68k-atari-mint-ranlib

# Read LDG_LDFLAGS, LDG_STATIC_DIR
LDG_LDFLAGS=
LDG_STATIC_DIR="$CROSSDIR_ROOT/m68k-atari-mint/lib"
source profiles/$1/compile.txt

CFLAGS="-O2 -fomit-frame-pointer"

# m68000

BUILD_DIR=build/lib/$1
TARGET_DIR=lib/ldg
TMP=`echo $LDG_LDFLAGS | sed "s%-l$1%$LDG_STATIC_DIR/lib$1.a%"`
LDFLAGS="-L$TARGET_DIR $TMP -lgem -lldg"

mkdir -p $BUILD_DIR
mkdir -p $TARGET_DIR

$CC $CFLAGS -I. -c src/$1/linker-ldg.S -o $BUILD_DIR/linker-ldg.o
$CC -o $TARGET_DIR/$1.ldg $BUILD_DIR/linker-ldg.o $LDFLAGS

$CC $CFLAGS -I. -c src/$1/loader-ldg.S -o $BUILD_DIR/loader-ldg.o
$AR cru $TARGET_DIR/lib$1.a $BUILD_DIR/loader-ldg.o
$RANLIB $TARGET_DIR/lib$1.a

# m68020

BUILD_DIR=build/lib/m68020/$1
TARGET_DIR=lib/ldg/m68020
TMP=`echo $LDG_LDFLAGS | sed "s%-l$1%$LDG_STATIC_DIR/m68020/lib$1.a%"`
LDFLAGS="-Llib/ldg $TMP -lgem -lldg"

mkdir -p $BUILD_DIR
mkdir -p $TARGET_DIR

$CC -m68020 $CFLAGS -I. -c src/$1/linker-ldg.S -o $BUILD_DIR/linker-ldg.o
$CC -m68020 -o $TARGET_DIR/$1.ldg $BUILD_DIR/linker-ldg.o $LDFLAGS

#$CC -m68020 $CFLAGS -I. -c src/$1/loader-ldg.c -o $BUILD_DIR/loader-ldg.o
#$AR cru $TARGET_DIR/lib$1.a $BUILD_DIR/loader-ldg.o
#$RANLIB $TARGET_DIR/lib$1.a

# m68020-60

BUILD_DIR=build/lib/m68020-60/$1
TARGET_DIR=lib/ldg/m68020-60
TMP=`echo $LDG_LDFLAGS | sed "s%-l$1%$LDG_STATIC_DIR/m68020-60/lib$1.a%"`
LDFLAGS="-Llib/ldg $TMP -lgem -lldg"

mkdir -p $BUILD_DIR
mkdir -p $TARGET_DIR

$CC -m68020-60 $CFLAGS -I. -c src/$1/linker-ldg.S -o $BUILD_DIR/linker-ldg.o
$CC -m68020-60 -o $TARGET_DIR/$1.ldg $BUILD_DIR/linker-ldg.o $LDFLAGS

#$CC -m68020-60 $CFLAGS -I. -c src/$1/loader-ldg.c -o $BUILD_DIR/loader-ldg.o
#$AR cru $TARGET_DIR/lib$1.a $BUILD_DIR/loader-ldg.o
#$RANLIB $TARGET_DIR/lib$1.a
